#ifndef _LPCUART_HWDEFS_H
#define _LPCUART_HWDEFS_H

#define LPC_UART_FCR_ENABLE_FIFO 0x01
#define LPC_UART_FCR_CLEAR_RCVR	0x02
#define LPC_UART_FCR_CLEAR_XMIT	0x04
#define LPC_UART_FCR_DMA_SELECT	0x08
#define LPC_UART_FCR_TRIGGER_MASK 0xC0
#define LPC_UART_FCR_TRIGGER_1	0x00
#define LPC_UART_FCR_TRIGGER_4	0x40
#define LPC_UART_FCR_TRIGGER_8	0x80
#define LPC_UART_FCR_TRIGGER_14	0xC0

#define LPC_UART_LCR_DLAB	0x80
#define LPC_UART_LCR_SBC	0x40
#define LPC_UART_LCR_SPAR	0x20
#define LPC_UART_LCR_EPAR	0x10
#define LPC_UART_LCR_PARITY	0x08
#define LPC_UART_LCR_STOP	0x04
#define LPC_UART_LCR_WLEN5	0x00
#define LPC_UART_LCR_WLEN6	0x01
#define LPC_UART_LCR_WLEN7	0x02
#define LPC_UART_LCR_WLEN8	0x03

#define LPC_UART_LSR_TEMT	0x40
#define LPC_UART_LSR_THRE	0x20
#define LPC_UART_LSR_BI		0x10
#define LPC_UART_LSR_FE		0x08
#define LPC_UART_LSR_PE		0x04
#define LPC_UART_LSR_OE		0x02
#define LPC_UART_LSR_DR		0x01

#define LPC_UART_IIR_NO_INT	0x01
#define LPC_UART_IIR_ID		0x06

#define LPC_UART_IIR_MSI	0x00
#define LPC_UART_IIR_THRI	0x02
#define LPC_UART_IIR_RDI	0x04
#define LPC_UART_IIR_RLSI	0x06

#define LPC_UART_IER_MSI	0x08
#define LPC_UART_IER_RLSI	0x04
#define LPC_UART_IER_THRI	0x02
#define LPC_UART_IER_RDI	0x01

#define LPC_UART_MCR_CTSEN	0x80
#define LPC_UART_MCR_RTSEN	0x40
#define LPC_UART_MCR_LOOP	0x10
#define LPC_UART_MCR_OUT2	0x08
#define LPC_UART_MCR_OUT1	0x04
#define LPC_UART_MCR_RTS	0x02
#define LPC_UART_MCR_DTR	0x01

#define LPC_UART_MSR_DCD	0x80
#define LPC_UART_MSR_RI		0x40
#define LPC_UART_MSR_DSR	0x20
#define LPC_UART_MSR_CTS	0x10
#define LPC_UART_MSR_DDCD	0x08
#define LPC_UART_MSR_TERI	0x04
#define LPC_UART_MSR_DDSR	0x02
#define LPC_UART_MSR_DCTS	0x01

#define LPC_UART_8N1      (LPC_UART_LCR_WLEN8 )
#define LPC_UART_7N1      (LPC_UART_LCR_WLEN7 )
#define LPC_UART_8N2      (LPC_UART_LCR_WLEN8 | LPC_UART_LCR_STOP)
#define LPC_UART_7N2      (LPC_UART_LCR_WLEN7 | LPC_UART_LCR_STOP)
#define LPC_UART_8E1      (LPC_UART_LCR_WLEN8 | LPC_UART_LCR_PARITY | LPC_UART_LCR_EPAR)
#define LPC_UART_7E1      (LPC_UART_LCR_WLEN7 | LPC_UART_LCR_PARITY | LPC_UART_LCR_EPAR)
#define LPC_UART_8E2      (LPC_UART_LCR_WLEN8 | LPC_UART_LCR_PARITY | LPC_UART_LCR_EPAR | LPC_UART_LCR_STOP)
#define LPC_UART_7E2      (LPC_UART_LCR_WLEN7 | LPC_UART_LCR_PARITY | LPC_UART_LCR_EPAR | LPC_UART_LCR_STOP)
#define LPC_UART_8O1      (LPC_UART_LCR_WLEN8 | LPC_UART_LCR_PARITY )
#define LPC_UART_7O1      (LPC_UART_LCR_WLEN7 | LPC_UART_LCR_PARITY )
#define LPC_UART_8O2      (LPC_UART_LCR_WLEN8 | LPC_UART_LCR_PARITY | LPC_UART_LCR_STOP)
#define LPC_UART_7O2      (LPC_UART_LCR_WLEN7 | LPC_UART_LCR_PARITY | LPC_UART_LCR_STOP)

#define LPC_UART_FIFO_OFF (0x00)
#define LPC_UART_FIFO_1   (LPC_UART_FCR_ENABLE_FIFO | LPC_UART_FCR_TRIGGER_1)
#define LPC_UART_FIFO_4   (LPC_UART_FCR_ENABLE_FIFO | LPC_UART_FCR_TRIGGER_4)
#define LPC_UART_FIFO_8   (LPC_UART_FCR_ENABLE_FIFO | LPC_UART_FCR_TRIGGER_8)
#define LPC_UART_FIFO_14  (LPC_UART_FCR_ENABLE_FIFO | LPC_UART_FCR_TRIGGER_14)

#endif /*_LPCUART_HWDEFS_H*/